function AuthManager(){
	this.tempToken = null;
	
	this.isFirstAuth = true;
	this.authToken = loadPref("authToken");
	this.authTokenExpiry = loadPref("authTokenExpiry");
	
	if(this.authToken != null && this.authTokenExpiry != null)
		this.isFirstAuth = false;
	
	this.widgetDisabled = false;
    this.subscriptionExpired = false;
}

AuthManager.prototype.setup = function(){
	var _self = this;
	document.getElementById("sheet-welcome-register").onclick 				= function(){ _self.register()};
	document.getElementById("sheet-welcome-auth").onclick 					= function(){ _self.doAuth()};
	document.getElementById("sheet-auth-expired-auth").onclick 				= function(){ _self.doAuth()};
	document.getElementById("sheet-auth-expired-auth-token").onclick 		= function(){ _self.hideNoTokenSheet(); _self.doAuth(); _self.showExpiredSheet()};
	document.getElementById("sheet-auth-expired-fetchtoken-token").onclick 	= function(){ _self.hideNoTokenSheet(); _self.fetchToken()};
	document.getElementById("back-deauthorise").onclick 					= function(){ _self.deauthorize()};
	document.getElementById("sheet-sub-expired-auth").onclick 				= function(){ _self.support()};
	document.getElementById("sheet-sub-expired-renew").onclick 				= function(){ _self.renew()};
}

AuthManager.prototype.register = function(){
	widget.openURL("http://www.icetv.com.au/cgi-bin/webwidget.cgi");
}

AuthManager.prototype.support = function(){
	widget.openURL("http://www.icetv.com.au/cgi-bin/webpage.cgi?op=show_contact");
}

AuthManager.prototype.renew = function(){
	widget.openURL("http://www.icetv.com.au/about/subscribe.shtml");
}

//AuthManager.prototype.isSubExpired = function(){
//	return this.subscriptionExpired;
//}

AuthManager.prototype.expire = function(){
	clearInterval(mainTimer);
	mainTimer = null;

	document.getElementById("frontSpinnerContainer").style.display = "none";
	clearInterval(bigSpinnerTimer);
	bigSpinnerTimer = null;
	
	sht.forceCloseSheets();
	this.showExpiredSheet();

	epg.clear();
	popular.clear();
	mgu.clear();
	mgs.clear();
	fav.clear();
	rcm.clear();
		
	initialSetupComplete = false;
	epgLoaded = false;
	popLoaded = false;
	mguLoaded = false;
	mgsLoaded = false;
	rcmLoaded = false;
	favLoaded = false;
	dvLoaded = false;
	chmLoaded = false;

	document.getElementById("main_container").style.height = "74px"
	document.getElementById("main_base").style.top = "146px"

	document.getElementById("controls-filler").style.display = "block";
	document.getElementById("controls-filler").style.top = "0px";

	document.getElementById("epg-controls").style.display = "none";
	document.getElementById("popular-controls").style.display = "none";
	document.getElementById("my-guide-upcoming-controls").style.display = "none";
	document.getElementById("my-guide-series-controls").style.display = "none";
	document.getElementById("epg-controls").style.display = "none";

	document.getElementById("epg_container").style.display = "none";
	document.getElementById("popular_container").style.display = "none";
	document.getElementById("myguideupcoming_container").style.display = "none";
	document.getElementById("myguideseries_container").style.display = "none";
	document.getElementById("recommended_container").style.display = "none";
}

AuthManager.prototype.subExpired = function(){
	clearInterval(mainTimer);
	mainTimer = null;

	document.getElementById("frontSpinnerContainer").style.display = "none";
	clearInterval(bigSpinnerTimer);
	bigSpinnerTimer = null;
	
	sht.forceCloseSheets();
	this.showSubExpiredSheet();

	epg.clear();
	popular.clear();
	mgu.clear();
	mgs.clear();
	fav.clear();
	rcm.clear();
		
	initialSetupComplete = false;
	epgLoaded = false;
	popLoaded = false;
	mguLoaded = false;
	mgsLoaded = false;
	rcmLoaded = false;
	favLoaded = false;
	dvLoaded = false;
	chmLoaded = false;

	document.getElementById("main_container").style.height = "74px"
	document.getElementById("main_base").style.top = "146px"

	document.getElementById("controls-filler").style.display = "block";
	document.getElementById("controls-filler").style.top = "0px";

	document.getElementById("epg-controls").style.display = "none";
	document.getElementById("popular-controls").style.display = "none";
	document.getElementById("my-guide-upcoming-controls").style.display = "none";
	document.getElementById("my-guide-series-controls").style.display = "none";
	document.getElementById("epg-controls").style.display = "none";

	document.getElementById("epg_container").style.display = "none";
	document.getElementById("popular_container").style.display = "none";
	document.getElementById("myguideupcoming_container").style.display = "none";
	document.getElementById("myguideseries_container").style.display = "none";
	document.getElementById("recommended_container").style.display = "none";
}


AuthManager.prototype.isExpired = function(){
	if(!this.authTokenExpiry)
		return true;
		
	var currentDate = new Date();
	var authTokenExpiryDate;

	authTokenExpiryDate = new Date();
	authTokenExpiryDate.setUTCFullYear(	parseInt(this.authTokenExpiry.substring(0,4), 10),
										parseInt(this.authTokenExpiry.substring(5,7), 10)-1,
										parseInt(this.authTokenExpiry.substring(8,10), 10) );
										
	authTokenExpiryDate.setUTCHours( parseInt(this.authTokenExpiry.substring(11,13), 10),
										parseInt(this.authTokenExpiry.substring(14,16), 10),
										parseInt(this.authTokenExpiry.substring(17,19), 10));

	return authTokenExpiryDate.getTime() < currentDate.getTime();
}

AuthManager.prototype.showExpiredSheet = function(){
	this.disableWidget();
	document.getElementById("sheet-container").style.display = "block";
	document.getElementById("auth-expired-sheet").style.display = "block";
	document.getElementById("sheet-container").style.height = document.getElementById("auth-expired-sheet").style.height;
	document.getElementById("widgetfront").style.height = (72 + parseInt(document.getElementById("auth-expired-sheet").style.height, 10)) + "px";
	window.resizeTo(window.outerWidth, 30 + (72 + parseInt(document.getElementById("auth-expired-sheet").style.height, 10)));
}

AuthManager.prototype.hideExpiredSheet = function(){
	document.getElementById("sheet-container").style.display = "none";
	document.getElementById("auth-expired-sheet").style.display = "none";
}


AuthManager.prototype.showSubExpiredSheet = function(){
	this.disableWidget();
	document.getElementById("sheet-container").style.display = "block";
	document.getElementById("sub-expired-sheet").style.display = "block";
	document.getElementById("sheet-container").style.height = document.getElementById("sub-expired-sheet").style.height;
	document.getElementById("widgetfront").style.height = (72 + parseInt(document.getElementById("sub-expired-sheet").style.height, 10)) + "px";
	window.resizeTo(window.outerWidth, 30 + (72 + parseInt(document.getElementById("sub-expired-sheet").style.height, 10)));
}

AuthManager.prototype.showNoTokenSheet = function(){
	this.disableWidget();
	document.getElementById("sheet-container").style.display = "block";
	document.getElementById("no-token-sheet").style.display = "block";
	document.getElementById("sheet-container").style.height = document.getElementById("no-token-sheet").style.height;
	document.getElementById("widgetfront").style.height = (72 + parseInt(document.getElementById("no-token-sheet").style.height, 10)) + "px";
	window.resizeTo(window.outerWidth, 30 + (72 + parseInt(document.getElementById("no-token-sheet").style.height, 10)));
}

AuthManager.prototype.hideNoTokenSheet = function(){
	document.getElementById("sheet-container").style.display = "none";
	document.getElementById("no-token-sheet").style.display = "none";
}

AuthManager.prototype.hideWelcomeSheet = function(){
	document.getElementById("sheet-container").style.display = "none";
	document.getElementById("welcome-sheet").style.display = "none";
}

AuthManager.prototype.fetchToken = function(){
	var _self = this;
	if(!this.downloader)
		this.downloader = new FeedDownloader("token", function(json){_self.processTokenResponse(json); });

	api_check = hex_sha1(api_secret + 'format' + 'json' + 'temp_token' + this.tempToken);
	authTokenUrl = host_url + '?op=' + 'GetAuthToken' + '&api_key=' + api_key + '&format=' + 'json' + '&temp_token=' + this.tempToken + '&api_check=' + api_check; 
	this.downloader.address = authTokenUrl;
	this.downloader.callback = function(json){_self.processFinalTokenResponse(json);}

	this.downloader.fetchURL();

}
	
AuthManager.prototype.processFinalTokenResponse = function(response){
	var tokendata;
	
	try {
		tokendata = eval(response)
	} catch(error){
		DEBUGLOG("error parsing token response");
	}
	if(!tokendata){
		DEBUGLOG("error parsing token response");
		return;
	}
//	tokendata = tokendata.shift();
	
	this.authToken = tokendata[0]['auth_token'];
	this.authTokenExpiry = tokendata[0]['expiry_date'];
	
    if(!this.authToken || !this.authTokenExpiry) {
        DEBUGLOG("AuthManager.js[133]: No token!!");
        this.hideExpiredSheet();
        this.showNoTokenSheet();
        return;
    }
        
	savePref(this.authToken, "authToken");
	savePref(this.authTokenExpiry, "authTokenExpiry");
	
	if(parseInt(loadPref("firstAuth"), 10) == 0 && this.isFirstAuth)
		savePref(1, "firstAuth");
	else
		savePref(2, "firstAuth");
	

//	this.enableWidget();

	var _self = this;
	var sheet;
	if(document.getElementById("welcome-sheet").style.display == "block")
		sheet = document.getElementById("welcome-sheet");
	else
		sheet = document.getElementById("auth-expired-sheet");

	var slide = new AnimationObject(sheet);
	slide.setOptions(kAnimateOptionsHide, 10);
	slide.pushPhase(kAnimatorMoveVerticalTop, parseInt(sheet.style.top, 10), -parseInt(document.getElementById("sheet-container").style.height, 10), 10, 0, null)

	sht.animator.purge();
	sht.animator.purgeCallbacks();
	sht.animator.pushCallback(function(){ _self.sheetSlideFinished(); });
	sht.animator.pushGroup(Array(slide));
	sht.animator.prepare(200, 10);
	sht.animator.run();
}

AuthManager.prototype.closeSheet = function(sheet) {
	var _self = this;
	var slide = new AnimationObject(sheet);
	slide.setOptions(kAnimateOptionsHide, 10);
	slide.pushPhase(kAnimatorMoveVerticalTop, parseInt(sheet.style.top, 10), -parseInt(document.getElementById("sheet-container").style.height, 10), 10, 0, null)

	sht.animator.purge();
	sht.animator.purgeCallbacks();
//	sht.animator.pushCallback(function(){ _self.sheetSlideFinished(); });
	sht.animator.pushGroup(Array(slide));
	sht.animator.prepare(200, 10);
	sht.animator.run();
}

AuthManager.prototype.sheetSlideFinished = function(){
	selectedPage = -1;
	document.getElementById("sheet-container").style.display = "none"
	this.enableWidget();
	runWidget();
}

AuthManager.prototype.generateAuthenticateUrl = function(tempToken){
	api_check = hex_sha1(api_secret + 'temp_token' + tempToken );
	tempTokenUrl = host_url + '?op=' + 'login' + '&api_key=' + api_key + '&temp_token=' + tempToken + '&api_check=' + api_check; 
	return tempTokenUrl;
}


AuthManager.prototype.processTempTokenResponse = function(response){
	var tokendata = eval(response)
	if(!tokendata){
		return;
	}
	tokendata = tokendata.shift();
	
	this.tempToken = tokendata['temp_token'];
	if(!this.tempToken){
		return;
	}

	tempTokenUrl = generateAuthenticateUrl(this.tempToken);
	widget.openURL(tempTokenUrl);
	
	var _self = this;

	document.getElementById("sheet-welcome-fetchtoken").onclick = function(){ _self.hideWelcomeSheet(); _self.fetchToken()};
	document.getElementById("sheet-welcome-fetchtoken").setAttribute("class", "sheet-welcome-fetchtoken");
	document.getElementById("sheet-auth-expired-fetchtoken").onclick = function(){ _self.hideExpiredSheet(); _self.fetchToken()};
	document.getElementById("sheet-welcome-fetchtoken").style.opacity = 1
	document.getElementById("sheet-auth-expired-fetchtoken").style.opacity = 1
	document.getElementById("sheet-auth-expired-fetchtoken").setAttribute("class", "sheet-welcome-fetchtoken");
}

AuthManager.prototype.doAuth = function() {
	var _self = this;
	if(!this.downloader)
		this.downloader = new FeedDownloader("token", function(){});

	api_check = hex_sha1(api_secret + 'format' + 'json');
	tempTokenUrl = host_url + '?op=' + 'GetTempToken' + '&api_key=' + api_key + '&format=' + 'json' + '&api_check=' + api_check; 
	this.downloader.address = tempTokenUrl;
	this.downloader.callback = function(json){_self.processTempTokenResponse(json);}

	this.downloader.fetchURL();
}

AuthManager.prototype.disableWidget = function(){
	document.getElementById("mode-selector-epg").setAttribute("class", "mode-epg");
	document.getElementById("mode-selector-popular").setAttribute("class", "mode-popular");
	document.getElementById("mode-selector-myguideupcoming").setAttribute("class", "mode-myguideupcoming");
	document.getElementById("mode-selector-myguideseries").setAttribute("class", "mode-myguideseries");
	document.getElementById("mode-selector-recommended").setAttribute("class", "mode-recommended");
	
	document.getElementById("mode-selector-epg").style.opacity = 0.5;
	document.getElementById("mode-selector-popular").style.opacity = 0.5;
	document.getElementById("mode-selector-myguideseries").style.opacity = 0.5;
	document.getElementById("mode-selector-myguideupcoming").style.opacity = 0.5;
	document.getElementById("mode-selector-recommended").style.opacity = 0.5;
	document.getElementById("mode-selector-prefs").style.opacity = 0.5;
	document.getElementById("mode-selector-prefs").setAttribute("onclick", "")

    DEBUGLOG("AuthManager.js[253]: Setting widgetDisabled = TRUE");
	this.widgetDisabled = true;
}

AuthManager.prototype.enableWidget = function(){
    DEBUGLOG("AuthManager.js[258]: Setting widgetDisabled = FALSE");
	this.widgetDisabled = false;

	document.getElementById("mode-selector-epg").setAttribute("class", "mode-epg");
	document.getElementById("mode-selector-popular").setAttribute("class", "mode-popular");
	document.getElementById("mode-selector-myguideupcoming").setAttribute("class", "mode-myguideupcoming");
	document.getElementById("mode-selector-myguideseries").setAttribute("class", "mode-myguideseries");
	document.getElementById("mode-selector-recommended").setAttribute("class", "mode-recommended");
	
	document.getElementById("mode-selector-epg").style.opacity = 1.0;
	document.getElementById("mode-selector-popular").style.opacity = 1.0;
	document.getElementById("mode-selector-myguideseries").style.opacity = 1.0;
	document.getElementById("mode-selector-myguideupcoming").style.opacity = 1.0;
	document.getElementById("mode-selector-recommended").style.opacity = 1.0;
	document.getElementById("mode-selector-prefs").style.opacity = 1.0;
	document.getElementById("mode-selector-prefs").setAttribute("onclick", "showPrefs()")
}

AuthManager.prototype.deauthorize = function(){
	var _self = this;
	if(!this.downloader)
		this.downloader = new FeedDownloader("token", function(){});

	api_check = hex_sha1(api_secret + 'auth_token' + this.authToken + 'format' + 'json');
	deleteAuthTokenUrl = host_url + '?op=' + 'DeleteAuthToken' + '&api_key=' + api_key + '&auth_token=' + this.authToken + '&format=' + 'json' + '&api_check=' + api_check; 
	this.downloader.address = deleteAuthTokenUrl;
	this.downloader.callback = function(json){_self.processDeleteTokenResponse(json);}

	this.downloader.fetchURL();
}

AuthManager.prototype.processDeleteTokenResponse = function(response){
	var tokendata = eval(response)
	if(!tokendata)
		return;
	tokendata = tokendata.shift();
	
	DEBUGLOG(tokendata["return_code"])
	
	if(tokendata["return_code"] == "0"){
		savePref("", "authToken");
		savePref("", "authTokenExpiry");
		savePref("0", "firstAuth");
		savePref("0", "shownSubscribeSheet");

		this.isFirstAuth = true;
			
		sht.forceCloseSheets();
		this.disableWidget();
		//this.showExpiredSheet();
	
		epg.clear();
		popular.clear();
		mgu.clear();
		mgs.clear();
		fav.clear();
		rcm.clear();
			
		initialSetupComplete = false;
		epgLoaded = false;
		popLoaded = false;
		mguLoaded = false;
		mgsLoaded = false;
		rcmLoaded = false;
		favLoaded = false;
		dvLoaded = false;
		chmLoaded = false;
		
		document.getElementById("main_container").style.height = "74px"
		document.getElementById("main_base").style.top = "146px"
	
		document.getElementById("controls-filler").style.display = "block";
		document.getElementById("controls-filler").style.top = "0px";
	
		document.getElementById("epg-controls").style.display = "none";
		document.getElementById("popular-controls").style.display = "none";
		document.getElementById("my-guide-upcoming-controls").style.display = "none";
		document.getElementById("my-guide-series-controls").style.display = "none";
		document.getElementById("epg-controls").style.display = "none";
		document.getElementById("recommended-controls").style.display = "none";
	
		document.getElementById("epg_container").style.display = "none";
		document.getElementById("popular_container").style.display = "none";
		document.getElementById("myguideupcoming_container").style.display = "none";
		document.getElementById("myguideseries_container").style.display = "none";
		document.getElementById("recommended_container").style.display = "none";
		
		document.getElementById("sheet-welcome-fetchtoken").onclick = null;
		document.getElementById("sheet-auth-expired-fetchtoken").onclick = null;
		document.getElementById("sheet-welcome-fetchtoken").style.opacity = 0.5
		document.getElementById("sheet-auth-expired-fetchtoken").style.opacity = 0.5
		document.getElementById("sheet-welcome-fetchtoken").setAttribute("class", "sheet-welcome-fetchtoken disabled");
		document.getElementById("sheet-auth-expired-fetchtoken").setAttribute("class", "sheet-welcome-fetchtoken disabled");

		var front = document.getElementById("widgetfront");
		var back = document.getElementById("widgetback");
	
		if (window.widget)
			widget.prepareForTransition("ToFront");
		
		front.style.display="block";
		back.style.display="none";
	
		if (window.widget)		
			setTimeout ('widget.performTransition();', 0);	
		backside = false;

		document.getElementById("sheet-container").style.display = "block";
		document.getElementById("welcome-sheet").style.display = "block";
		document.getElementById("welcome-sheet").style.top = "0px";
		document.getElementById("sheet-container").style.height = document.getElementById("welcome-sheet").style.height;
		document.getElementById("widgetfront").style.height = (72 + parseInt(document.getElementById("welcome-sheet").style.height, 10)) + "px";
		window.resizeTo(window.outerWidth, 65 + (72 + parseInt(document.getElementById("auth-expired-sheet").style.height, 10)));
	}
}

AuthManager.prototype.clearContent = function(){
	epg.clear();
	popular.clear();
	mgu.clear();
	mgs.clear();
	fav.clear();
	rcm.clear();

	epg.hide();
	popular.hide();
	mgu.hide();
	mgs.hide();
	rcm.hide();
		
	document.getElementById("controls-filler").style.display = "block";
	document.getElementById("controls-filler").style.top = "0px";
	document.getElementById("epg-controls").style.display = "none";
	document.getElementById("popular-controls").style.display = "none";
	document.getElementById("my-guide-upcoming-controls").style.display = "none";
	document.getElementById("my-guide-series-controls").style.display = "none";
	document.getElementById("recommended-controls").style.display = "none";
}