function ChannelDragController(element, id, chk, left, right){
	var _self = this;
	this.container = element;
	this.id = id;
	left.onmousedown = function(event){ _self.startDrag(event); }
	right.onmousedown = function(event){ _self.startDrag(event); }
	
	this.visibilityCheckbox = chk;
	this.visibilityCheckbox.onclick = function(){ _self.toggleVisibility(); }
	this.visibilityCheckbox.onmousedown = function(){}
	
	this.inDrag = false;
	
	this.animator = new AnimationController();
	this.animateFinalPosition = 0;
	
	this.dragHandler = function(event){ _self.doDrag(event); };
	this.dragEndHandler = function(){ _self.endDrag(); };
}

ChannelDragController.prototype.toggleVisibility = function(){
	if(this.chkhidden){
		this.chkhidden = false;
		this.visibilityCheckbox.style.backgroundImage = "url(images/back/checkbox_on.png)"
		chm.setHidden(this.id, false)
	} else {
		this.chkhidden = true;
		this.visibilityCheckbox.style.backgroundImage = "url(images/back/checkbox_off.png)"
		chm.setHidden(this.id, true)
	}
}

ChannelDragController.prototype.setCheckboxVisibility = function(chkvisibility){
	this.chkhidden = chkvisibility;
}

ChannelDragController.prototype.animationFinished = function(){
	this.container.style.zIndex = 1;
	document.getElementById("back_drag_shadow").style.display = "none";
}

ChannelDragController.prototype.animateToPosition = function(position, shadow){
	this.animateFinalPosition = position;
	this.animator.purge();
	
	var _self = this;
	var move = new AnimationObject(this.container);
	move.setOptions(0, 10);
	move.pushPhase(kAnimatorMoveVerticalTop, parseInt(this.container.style.top, 10), position, 10, 0, function(){ _self.animationFinished()})

	if(shadow){
		var shadow = new AnimationObject(document.getElementById("back_drag_shadow"));
		shadow.setOptions(0, 10);
		shadow.pushPhase(kAnimatorMoveVerticalTop, parseInt(document.getElementById("back_drag_shadow").style.top, 10), parseInt(document.getElementById("channel_list").style.top, 10) + position - 11, 10, 0, null)
		this.animator.pushGroup(Array(shadow));

		var fade = new AnimationObject(document.getElementById("back_drag_shadow"));
		fade.setOptions(kAnimateOptionsHide, 20);
		fade.pushPhase(kAnimateOpacity, 1, 0, 10, 10, null)
		this.animator.pushGroup(Array(fade));
	}
	this.animator.pushGroup(Array(move));
	this.animator.prepare(400, 20);
	this.animator.run();
}

ChannelDragController.prototype.startDrag = function(event){
	document.addEventListener("mousemove",this.dragHandler, false);
	document.addEventListener("mouseup", this.dragEndHandler, false);
	this.inDrag = false;
	bck.startDrag(this, event);
}

ChannelDragController.prototype.doDrag = function(event){
	if(!this.inDrag)
		this.inDrag = true;
	bck.doDrag(event);
}

ChannelDragController.prototype.endDrag = function(){
	document.removeEventListener("mousemove",this.dragHandler, false);
	document.removeEventListener("mouseup", this.dragEndHandler, false);
	if(this.inDrag)
		bck.endDrag();
	else
		bck.killShadow();
	this.inDrag = false;
	this.container.zOrder = 1;
}

function BackController(){
	this.drag = {};
	this.channelDisplayOrder = Array();
	this.channelObjects = new Object();
}

BackController.prototype.setup = function(){
	var _self = this;
	document.getElementById("now_and_next").onchange = function(){ _self.setVisibleShows(); };

//	if(parseInt(preferences.nowAndNext.value, 10) == 3){
//		shows3.checked = true;
//		back_visible_shows_text.data = "3 Programs"
//	} else {
//		shows5.checked = true;
//		back_visible_shows_text.data = "5 Programs"
//	}
//	
//	back_visible_shows.onClick = function(){ popupMenu( _self.showNumberMenu, back_visible_shows.hOffset, back_visible_shows.vOffset + back_visible_shows.superview.vOffset); }


//	this.timeFormatMenu = Array();
//	var time12 = new MenuItem();
//	time12.enabled = true;
//	time12.title = "12 hour clock";
//	time12.onSelect = function(){ _self.setTimeFormat(12); }		
//	this.timeFormatMenu.push(time12)
//
//	var time24 = new MenuItem();
//	time24.enabled = true;
//	time24.title = "24 hour clock";
//	time24.onSelect = function(){ _self.setTimeFormat(24); }
//	this.timeFormatMenu.push(time24)
//
//	if(parseInt(preferences.twentyFourHourClock.value, 10) == 12){
//		time12.checked = true;
//		back_time_format_text.data = "12 hour clock"
//	} else {
//		time24.checked = true;
//		back_time_format_text.data = "24 hour clock"
//	}
//	
//	back_time_format.onClick = function(){ popupMenu( _self.timeFormatMenu, back_visible_shows.hOffset, back_visible_shows.vOffset + back_visible_shows.superview.vOffset); }
}

BackController.prototype.setVisibleShows = function(){
	var shows = document.getElementById("now_and_next").selectedIndex;
	if(shows == 0){
		document.getElementById("back-texttvguide").innerText = "3 Programs"
		savePref(3, "nowAndNext");
		epg.setVisibleShows(3);
	} else {
		document.getElementById("back-texttvguide").innerText = "5 Programs"
		savePref(5, "nowAndNext");
		epg.setVisibleShows(5);
	}
}

BackController.prototype.setTimeFormat = function(format){
	if(format == 12){
		document.getElementById("filter_day_label").innerText = "12 hour clock"
	} else {
		document.getElementById("filter_day_label").innerText = "24 hour clock"
	}
	setPref(format, "twentyFourHourClock");
	epg.setTimeFormat(format);
	mgu.updateDisplay();
	buildHourMenu();
}

BackController.prototype.buildChannelLineup = function(channel){
	var channelList = chm.sortedList;
	document.getElementById("region_name").innerText = chm.region;
	
	this.channelDisplayOrder.length = 0;
	this.channelObjects = new Object();
	while(document.getElementById("channel_list").hasChildNodes())
		document.getElementById("channel_list").removeChild(document.getElementById("channel_list").firstChild);
	
	for(x=0;x<channelList.length;x++){		
		var container = document.createElement("div");
		container.setAttribute("style", "-apple-dashboard-region: dashboard-region(control rectangle);");
		container.style.background = "url(images/back/channel.png)"
		container.style.top = (x * 20) + "px";
		container.style.position = "absolute"
		container.style.left = "19px";
		container.style.height = "20px";
		container.style.width = "262px";
		container.style.zIndex = 1;
		document.getElementById("channel_list").appendChild(container);

		var leftDrag = document.createElement("div");
		leftDrag.setAttribute("style", "-apple-dashboard-region: dashboard-region(control rectangle);");
		leftDrag.style.position = "absolute"
		leftDrag.style.left = "0px";
		leftDrag.style.height = "20px";
		leftDrag.style.width = "20px";
		leftDrag.style.zIndex = 1;
		container.appendChild(leftDrag);

		var rightDrag = document.createElement("div");
		rightDrag.setAttribute("style", "-apple-dashboard-region: dashboard-region(control rectangle);");
		rightDrag.style.position = "absolute"
		rightDrag.style.left = "42px";
		rightDrag.style.height = "20px";
		rightDrag.style.width = "220px";
		rightDrag.style.zIndex = 1;
		container.appendChild(rightDrag);
		
		var chk = document.createElement("div");
		if(chm.isHidden(channelList[x]))
			chk.style.background = "url(images/back/checkbox_off.png)"
		else
			chk.style.background = "url(images/back/checkbox_on.png)"
		chk.style.position = "absolute"
		chk.style.height = "20px";
		chk.style.width = "20px";
		chk.style.left = "19px";
		container.appendChild(chk);

		var controller = new ChannelDragController(container, channelList[x], chk, leftDrag, rightDrag)
		controller.setCheckboxVisibility(chm.isHidden(channelList[x]));
		this.channelDisplayOrder.push(channelList[x]);
		this.channelObjects[channelList[x]] = {container:container, id:channelList[x], controller:controller};

		var name = document.createElement("div");
		name.innerText = chm.nameForID(channelList[x]);
		name.style.font = "bold 11px Lucida Grande"
		name.style.position = "absolute"
		name.style.left = "45px";
		name.style.top = "3px";
		name.style.width = "170px";
		name.style.color = "rgba(0,0,0,0.7)";
		name.setAttribute("class", "ellipsis");
		container.appendChild(name);
	}
	document.getElementById("channel_list").style.height = (x * 20) + "px";
	document.getElementById("back-bottom").style.top = (82 + (x * 20)) + "px";
	document.getElementById("widgetback").style.height = (241 + 82 + (x * 20)) + "px"
	//back.height = 82 + (x * 20) + 214;
}

BackController.prototype.downloaderCallback = function(json){
}

BackController.prototype.startDrag = function(controller, event) {
	for(x=0;x<this.channelDisplayOrder.length;x++){
		this.channelObjects[this.channelDisplayOrder[x]].controller.container.style.zIndex = 1;
		if(this.channelObjects[this.channelDisplayOrder[x]].controller.animator.active)
			this.channelObjects[this.channelDisplayOrder[x]].controller.animator.cancel();
	}

	this.drag.element = controller.container;
	this.drag.controller = controller;
	this.drag.element.style.zIndex = 20;
		
	this.drag.origin = parseInt(this.drag.element.style.top, 10);
	this.drag.index = Math.floor(this.drag.origin / 20);
	this.drag.active = true;
 
    this.drag.offset = event.y;
    
 //   if(this.shadowAnimator)
   // 	this.shadowAnimator.kill();
    
    document.getElementById("back_drag_shadow").style.top = ((this.drag.index * 20) + parseInt(document.getElementById("channel_list").style.top, 10) - 11) + "px"
	document.getElementById("back_drag_shadow").style.display = "block";
	document.getElementById("back_drag_shadow").style.opacity = 1;
}

BackController.prototype.killShadow = function() {
    if(this.shadowAnimator)
    	this.shadowAnimator.kill();
    
	document.getElementById("back_drag_shadow").style.display = "none";
}

BackController.prototype.endDrag = function() {
	chm.setSortOrder(this.channelDisplayOrder)
//	savePreferences();
	
//	var _self = this;
//	this.shadowAnimator = new MoveAnimation(back_drag_shadow, 19, (this.drag.index * 20) + back_channels.vOffset - 11, 150, animator.kEaseNone, function(){ _self.shadowAnimationFinished()});
	
	this.drag.controller.animateToPosition(this.drag.index * 20, true)
}

BackController.prototype.shadowAnimationFinished = function(){
	document.getElementById("back_drag_shadow").style.display = "none";
	this.shadowAnimator = null;
}

BackController.prototype.doDrag = function(event) {
  	var newposition = event.y - this.drag.offset + this.drag.origin;
	if(newposition < 0)
		newposition = 0;
	
	if(newposition > (parseInt(document.getElementById("channel_list").style.height, 10) - 20))
		newposition = parseInt(document.getElementById("channel_list").style.height, 10) - 20
	var newIndex = this.drag.index;
	newIndex = Math.floor((newposition + 10) / 20);
		
	if(newIndex != this.drag.index){
		var newcontent = Array();
		
		var draggedItem;
		for(x=0;x<this.channelDisplayOrder.length;x++){
			if(this.channelObjects[this.channelDisplayOrder[x]].container == this.drag.element){
				draggedItem = this.channelObjects[this.channelDisplayOrder[x]];
				break;
			}
		}

		for(x=0;x<this.channelDisplayOrder.length;x++){
			if(newIndex < this.drag.index){
				if(x == newIndex)
					newcontent[newcontent.length] = draggedItem.id;
			}
			if(this.channelObjects[this.channelDisplayOrder[x]].container != this.drag.element){
				newcontent[newcontent.length] = this.channelDisplayOrder[x];
			}
			if(newIndex > this.drag.index){
				if(x == newIndex)
					newcontent[newcontent.length] = draggedItem.id;
			}
		}

		this.channelDisplayOrder = newcontent;
		for(x=0;x<this.channelDisplayOrder.length;x++){
			if(this.channelObjects[this.channelDisplayOrder[x]].container != this.drag.element){
				var doSlide = false;
				if(parseInt(this.channelObjects[this.channelDisplayOrder[x]].container.style.top, 10) != (20 * x)){
					doSlide = true;	
				}
				
				if(doSlide){
					if(this.channelObjects[this.channelDisplayOrder[x]].controller.animator.active){
						if(this.channelObjects[this.channelDisplayOrder[x]].controller.animateFinalPosition == (20 * x)){
							continue;
						}
						this.channelObjects[this.channelDisplayOrder[x]].controller.animator.cancelWithoutFinishing();
					}
							
					this.channelObjects[this.channelDisplayOrder[x]].controller.animateToPosition(x * 20, false)
					//this.channelObjects[this.channelDisplayOrder[x]].controller.container.style.top = (x * 20) + "px"
				}
			}
		}
		this.drag.index = newIndex;
	}
	
	document.getElementById("back_drag_shadow").style.top = (newposition + parseInt(document.getElementById("channel_list").style.top, 10) - 11) + "px";
	this.drag.element.style.top = newposition + "px";
}